"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Clase base para los Worker y Fork
 */
class Base {
    /**
     * Contructor de la clase
     * @param conf Configuracion del servicio
     */
    constructor(conf, topic, span) {
        /**
         * Topico del servicio
         * @protected
         */
        this.Topic = '';
        this.config = conf;
        this.Topic = topic;
        this.span = span;
    }
    /**
     * Metodo que hace rel registro de Forks
     * para su utilizacion sobre los servicios.
     * @param conf Configuracion para el evento
     */
    forksConfig(conf) {
        return;
    }
    /**
     * Metodo para dar formato a los mensajes de salida.
     * @param data Datos a enviar
     * @param arg Argumentos extra
     */
    formatResponse(Data, ...arg) {
        // Variable para conocer si es un error o no
        let isError = false;
        // Validar si es un error
        if (arg[1] < 0) {
            isError = true;
        }
        // Objecto base de respuesta
        const response = {
            data: Data.data,
            headers: Data.headers,
            metadata: Data.metadata,
            response: {
                data: {
                    response: arg[0],
                },
                meta: {
                    id_transaction: Data.metadata.id_transaction,
                    status: isError ? 'ERROR' : 'SUCCESS',
                },
            },
            uuid: Data.uuid,
        };
        // Regresar todo
        return {
            errorCode: arg[1],
            response,
        };
    }
}
exports.default = Base;
